/******************************************************************************

MODULE:  CloseGeoTIFFFile

PURPOSE:  Close a TIFF

RETURN VALUE:
Type = int
Value           Description
-----           -----------
TRUE            Success  (always)
FALSE           Failure

HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  -------------------------------------
         06/00  Rob Burrell            Original Development
         01/01  John Rishea            Standardized formatting

NOTES:

******************************************************************************/

#include "GeoS2G.h"

int CloseGeoTIFFFile(GeoTIFFFD *geotiff)
{
  GTIFWriteKeys(geotiff->gtif);
  GTIFFree(geotiff->gtif);
  XTIFFClose(geotiff->tif);
  
  return 1;
}
